/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	kubeovnv1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeIptablesFIPRules implements IptablesFIPRuleInterface
type FakeIptablesFIPRules struct {
	Fake *FakeKubeovnV1
}

var iptablesfiprulesResource = schema.GroupVersionResource{Group: "kubeovn.io", Version: "v1", Resource: "iptables-fip-rules"}

var iptablesfiprulesKind = schema.GroupVersionKind{Group: "kubeovn.io", Version: "v1", Kind: "IptablesFIPRule"}

// Get takes name of the iptablesFIPRule, and returns the corresponding iptablesFIPRule object, and an error if there is any.
func (c *FakeIptablesFIPRules) Get(ctx context.Context, name string, options v1.GetOptions) (result *kubeovnv1.IptablesFIPRule, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(iptablesfiprulesResource, name), &kubeovnv1.IptablesFIPRule{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.IptablesFIPRule), err
}

// List takes label and field selectors, and returns the list of IptablesFIPRules that match those selectors.
func (c *FakeIptablesFIPRules) List(ctx context.Context, opts v1.ListOptions) (result *kubeovnv1.IptablesFIPRuleList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(iptablesfiprulesResource, iptablesfiprulesKind, opts), &kubeovnv1.IptablesFIPRuleList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kubeovnv1.IptablesFIPRuleList{ListMeta: obj.(*kubeovnv1.IptablesFIPRuleList).ListMeta}
	for _, item := range obj.(*kubeovnv1.IptablesFIPRuleList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested iptablesFIPRules.
func (c *FakeIptablesFIPRules) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(iptablesfiprulesResource, opts))
}

// Create takes the representation of a iptablesFIPRule and creates it.  Returns the server's representation of the iptablesFIPRule, and an error, if there is any.
func (c *FakeIptablesFIPRules) Create(ctx context.Context, iptablesFIPRule *kubeovnv1.IptablesFIPRule, opts v1.CreateOptions) (result *kubeovnv1.IptablesFIPRule, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(iptablesfiprulesResource, iptablesFIPRule), &kubeovnv1.IptablesFIPRule{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.IptablesFIPRule), err
}

// Update takes the representation of a iptablesFIPRule and updates it. Returns the server's representation of the iptablesFIPRule, and an error, if there is any.
func (c *FakeIptablesFIPRules) Update(ctx context.Context, iptablesFIPRule *kubeovnv1.IptablesFIPRule, opts v1.UpdateOptions) (result *kubeovnv1.IptablesFIPRule, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(iptablesfiprulesResource, iptablesFIPRule), &kubeovnv1.IptablesFIPRule{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.IptablesFIPRule), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeIptablesFIPRules) UpdateStatus(ctx context.Context, iptablesFIPRule *kubeovnv1.IptablesFIPRule, opts v1.UpdateOptions) (*kubeovnv1.IptablesFIPRule, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(iptablesfiprulesResource, "status", iptablesFIPRule), &kubeovnv1.IptablesFIPRule{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.IptablesFIPRule), err
}

// Delete takes name of the iptablesFIPRule and deletes it. Returns an error if one occurs.
func (c *FakeIptablesFIPRules) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(iptablesfiprulesResource, name, opts), &kubeovnv1.IptablesFIPRule{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeIptablesFIPRules) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(iptablesfiprulesResource, listOpts)

	_, err := c.Fake.Invokes(action, &kubeovnv1.IptablesFIPRuleList{})
	return err
}

// Patch applies the patch and returns the patched iptablesFIPRule.
func (c *FakeIptablesFIPRules) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *kubeovnv1.IptablesFIPRule, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(iptablesfiprulesResource, name, pt, data, subresources...), &kubeovnv1.IptablesFIPRule{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.IptablesFIPRule), err
}
