/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// IptablesSnatRuleLister helps list IptablesSnatRules.
// All objects returned here must be treated as read-only.
type IptablesSnatRuleLister interface {
	// List lists all IptablesSnatRules in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.IptablesSnatRule, err error)
	// Get retrieves the IptablesSnatRule from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.IptablesSnatRule, error)
	IptablesSnatRuleListerExpansion
}

// iptablesSnatRuleLister implements the IptablesSnatRuleLister interface.
type iptablesSnatRuleLister struct {
	indexer cache.Indexer
}

// NewIptablesSnatRuleLister returns a new IptablesSnatRuleLister.
func NewIptablesSnatRuleLister(indexer cache.Indexer) IptablesSnatRuleLister {
	return &iptablesSnatRuleLister{indexer: indexer}
}

// List lists all IptablesSnatRules in the indexer.
func (s *iptablesSnatRuleLister) List(selector labels.Selector) (ret []*v1.IptablesSnatRule, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.IptablesSnatRule))
	})
	return ret, err
}

// Get retrieves the IptablesSnatRule from the index for a given name.
func (s *iptablesSnatRuleLister) Get(name string) (*v1.IptablesSnatRule, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("iptablessnatrule"), name)
	}
	return obj.(*v1.IptablesSnatRule), nil
}
